/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
export let XYChart = /*@__PURE__*/ (() => {
    class XYChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.wo = null;
            this.wp = null;
            this.w5 = 0;
            this.w7 = 5;
            this.w6 = 0;
            this.w4 = 5;
            this.xm = 5;
            this.xo = 0;
            this.xn = 5;
            this.xl = 0;
            this.acf = null;
            this.acm = null;
            this.acd = null;
            this.ace = null;
            this.xg = 0;
            this.xx = 0;
            this.xf = NaN;
            this.xw = NaN;
            this.xi = NaN;
            this.xz = NaN;
            this.xh = NaN;
            this.xy = NaN;
            this.xe = NaN;
            this.xv = NaN;
            this.acl = null;
            this.acs = null;
            this.y7 = null;
            this.zb = null;
            this.y9 = null;
            this.zd = null;
            this.y2 = null;
            this.y3 = null;
            this.acg = null;
            this.acn = null;
            this.w8 = DeviceUtils.g(1);
            this.xp = DeviceUtils.g(1);
            this.w9 = DeviceUtils.g(1);
            this.xq = DeviceUtils.g(1);
            this.aci = null;
            this.acp = null;
            this.acj = null;
            this.acq = null;
            this.xa = DeviceUtils.g(1);
            this.xr = DeviceUtils.g(1);
            this.xb = DeviceUtils.g(8);
            this.xs = 0;
            this.ack = null;
            this.acr = null;
            this.xc = DeviceUtils.g(1);
            this.xt = DeviceUtils.g(1);
            this.y8 = null;
            this.zc = null;
            this.ach = null;
            this.aco = null;
            this.w3 = 0;
            this.xk = 0;
            this.w2 = NaN;
            this.xj = NaN;
            this.xd = 0;
            this.xu = -90;
            this.wy = false;
            this.wz = false;
            this.ab8 = 1;
            this.adb = 1;
            this.ab7 = 1;
            this.ab9 = 2;
            this.ac9 = 0;
            this.ada = 1;
            this.adf = 0;
            this.adg = 0;
            this.ww = 4;
            this.wu = 4;
            this.y6 = null;
            this.wi = null;
            this.za = null;
            this.wj = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.wm();
                let c = this.wn();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        sr() {
            super.sr();
            let a = this.wm();
            let b = this.wn();
            if (a != null && a.az != null) {
                this.acv = a.az.textColor;
            }
            if (b != null && b.az != null) {
                this.ac2 = b.az.textColor;
            }
            this.ac0 = AxisDefaults.j;
            this.ac7 = AxisDefaults.j;
            this.acw = AxisDefaults.h;
            this.ac3 = AxisDefaults.h;
            this.acz = AxisDefaults.g;
            this.ac6 = AxisDefaults.g;
        }
        th(a, b, c) {
            super.th(a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.abz((d) => d.leftMargin = this.x7);
                    break;
                case "XAxisLabelTopMargin":
                    this.abz((d) => d.topMargin = this.x9);
                    break;
                case "XAxisLabelRightMargin":
                    this.abz((d) => d.rightMargin = this.x8);
                    break;
                case "XAxisLabelBottomMargin":
                    this.abz((d) => d.bottomMargin = this.x6);
                    break;
                case "YAxisLabelLeftMargin":
                    this.ab4((d) => d.leftMargin = this.yo);
                    break;
                case "YAxisLabelTopMargin":
                    this.ab4((d) => d.topMargin = this.yq);
                    break;
                case "YAxisLabelRightMargin":
                    this.ab4((d) => d.rightMargin = this.yp);
                    break;
                case "YAxisLabelBottomMargin":
                    this.ab4((d) => d.bottomMargin = this.yn);
                    break;
                case "ActualItemsSource":
                case "ShouldDisplayMockData":
                case "ShouldUseSkeletonStyleForMockData":
                    this.act = this.vp(this.acv);
                    this.acu = this.vp(this.ac2);
                    break;
                case "XAxisLabelTextColor":
                    this.act = this.vp(this.acv);
                    break;
                case "YAxisLabelTextColor":
                    this.acu = this.vp(this.ac2);
                    break;
                case "ActualXAxisLabelTextColor":
                    this.abz((d) => d.textColor = this.act);
                    break;
                case "ActualYAxisLabelTextColor":
                    this.ab4((d) => d.textColor = this.acu);
                    break;
                case "XAxisTitleMargin":
                    this.ab1((d) => d.margin = this.yi);
                    break;
                case "YAxisTitleMargin":
                    this.ab6((d) => d.margin = this.yz);
                    break;
                case "XAxisTitleLeftMargin":
                    this.ab1((d) => d.leftMargin = this.yh);
                    break;
                case "YAxisTitleLeftMargin":
                    this.ab6((d) => d.leftMargin = this.yy);
                    break;
                case "XAxisTitleTopMargin":
                    this.ab1((d) => d.topMargin = this.yk);
                    break;
                case "YAxisTitleTopMargin":
                    this.ab6((d) => d.topMargin = this.y1);
                    break;
                case "XAxisTitleRightMargin":
                    this.ab1((d) => d.rightMargin = this.yj);
                    break;
                case "YAxisTitleRightMargin":
                    this.ab6((d) => d.rightMargin = this.y0);
                    break;
                case "XAxisTitleBottomMargin":
                    this.ab1((d) => d.bottomMargin = this.yg);
                    break;
                case "YAxisTitleBottomMargin":
                    this.ab6((d) => d.bottomMargin = this.yx);
                    break;
                case "XAxisTitleTextColor":
                    this.ab1((d) => d.textColor = this.ac1);
                    break;
                case "YAxisTitleTextColor":
                    this.ab6((d) => d.textColor = this.ac8);
                    break;
                case "XAxisFormatLabel":
                    this.abx((d) => d.au = this.wq);
                    break;
                case "YAxisFormatLabel":
                    this.ab2((d) => d.au = this.wr);
                    break;
            }
        }
        get wq() {
            return this.wo;
        }
        set wq(a) {
            let b = this.wq;
            if (a != b) {
                this.wo = a;
                this.te("XAxisFormatLabel", b, this.wq);
            }
        }
        get wr() {
            return this.wp;
        }
        set wr(a) {
            let b = this.wr;
            if (a != b) {
                this.wp = a;
                this.te("YAxisFormatLabel", b, this.wr);
            }
        }
        get x7() {
            return this.w5;
        }
        set x7(a) {
            let b = this.x7;
            if (a != b) {
                this.w5 = a;
                this.te("XAxisLabelLeftMargin", b, this.x7);
            }
        }
        get x9() {
            return this.w7;
        }
        set x9(a) {
            let b = this.x9;
            if (a != b) {
                this.w7 = a;
                this.te("XAxisLabelTopMargin", b, this.x9);
            }
        }
        get x8() {
            return this.w6;
        }
        set x8(a) {
            let b = this.x8;
            if (a != b) {
                this.w6 = a;
                this.te("XAxisLabelRightMargin", b, this.x8);
            }
        }
        get x6() {
            return this.w4;
        }
        set x6(a) {
            let b = this.x6;
            if (a != b) {
                this.w4 = a;
                this.te("XAxisLabelBottomMargin", b, this.x6);
            }
        }
        get yo() {
            return this.xm;
        }
        set yo(a) {
            let b = this.yo;
            if (a != b) {
                this.xm = a;
                this.te("YAxisLabelLeftMargin", b, this.yo);
            }
        }
        get yq() {
            return this.xo;
        }
        set yq(a) {
            let b = this.yq;
            if (a != b) {
                this.xo = a;
                this.te("YAxisLabelTopMargin", b, this.yq);
            }
        }
        get yp() {
            return this.xn;
        }
        set yp(a) {
            let b = this.yp;
            if (a != b) {
                this.xn = a;
                this.te("YAxisLabelRightMargin", b, this.yp);
            }
        }
        get yn() {
            return this.xl;
        }
        set yn(a) {
            let b = this.yn;
            if (a != b) {
                this.xl = a;
                this.te("YAxisLabelBottomMargin", b, this.yn);
            }
        }
        get acv() {
            return this.acf;
        }
        set acv(a) {
            let b = this.acv;
            if (a != b) {
                this.acf = a;
                this.te("XAxisLabelTextColor", b, this.acv);
            }
        }
        get ac2() {
            return this.acm;
        }
        set ac2(a) {
            let b = this.ac2;
            if (a != b) {
                this.acm = a;
                this.te("YAxisLabelTextColor", b, this.ac2);
            }
        }
        get act() {
            return this.acd;
        }
        set act(a) {
            let b = this.acd;
            if (a != b) {
                this.acd = a;
                this.te("ActualXAxisLabelTextColor", b, this.act);
            }
        }
        get acu() {
            return this.ace;
        }
        set acu(a) {
            let b = this.ace;
            if (a != b) {
                this.ace = a;
                this.te("ActualYAxisLabelTextColor", b, this.acu);
            }
        }
        get yi() {
            return this.xg;
        }
        set yi(a) {
            let b = this.yi;
            if (a != b) {
                this.xg = a;
                this.te("XAxisTitleMargin", b, this.yi);
            }
        }
        get yz() {
            return this.xx;
        }
        set yz(a) {
            let b = this.yz;
            if (a != b) {
                this.xx = a;
                this.te("YAxisTitleMargin", b, this.yz);
            }
        }
        get yh() {
            return this.xf;
        }
        set yh(a) {
            let b = this.yh;
            if (a != b) {
                this.xf = a;
                this.te("XAxisTitleLeftMargin", b, this.yh);
            }
        }
        get yy() {
            return this.xw;
        }
        set yy(a) {
            let b = this.yy;
            if (a != b) {
                this.xw = a;
                this.te("YAxisTitleLeftMargin", b, this.yy);
            }
        }
        get yk() {
            return this.xi;
        }
        set yk(a) {
            let b = this.yk;
            if (a != b) {
                this.xi = a;
                this.te("XAxisTitleTopMargin", b, this.yk);
            }
        }
        get y1() {
            return this.xz;
        }
        set y1(a) {
            let b = this.y1;
            if (a != b) {
                this.xz = a;
                this.te("YAxisTitleTopMargin", b, this.y1);
            }
        }
        get yj() {
            return this.xh;
        }
        set yj(a) {
            let b = this.yj;
            if (a != b) {
                this.xh = a;
                this.te("XAxisTitleRightMargin", b, this.yj);
            }
        }
        get y0() {
            return this.xy;
        }
        set y0(a) {
            let b = this.y0;
            if (a != b) {
                this.xy = a;
                this.te("YAxisTitleRightMargin", b, this.y0);
            }
        }
        get yg() {
            return this.xe;
        }
        set yg(a) {
            let b = this.yg;
            if (a != b) {
                this.xe = a;
                this.te("XAxisTitleBottomMargin", b, this.yg);
            }
        }
        get yx() {
            return this.xv;
        }
        set yx(a) {
            let b = this.yx;
            if (a != b) {
                this.xv = a;
                this.te("YAxisTitleBottomMargin", b, this.yx);
            }
        }
        get ac1() {
            return this.acl;
        }
        set ac1(a) {
            let b = this.ac1;
            if (a != b) {
                this.acl = a;
                this.te("XAxisTitleTextColor", b, this.ac1);
            }
        }
        get ac8() {
            return this.acs;
        }
        set ac8(a) {
            let b = this.ac8;
            if (a != b) {
                this.acs = a;
                this.te("YAxisTitleTextColor", b, this.ac8);
            }
        }
        ti(a, b, c) {
            super.ti(a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.abz((d) => d.textStyle = this.zv);
                    break;
                case "YAxisLabelTextStyle":
                    this.ab4((d) => d.textStyle = this.aa0);
                    break;
                case "XAxisTitleTextStyle":
                    this.ab1((d) => d.textStyle = this.aaj);
                    break;
                case "YAxisTitleTextStyle":
                    this.ab6((d) => d.textStyle = this.abo);
                    break;
            }
        }
        get zv() {
            return this.y7;
        }
        set zv(a) {
            let b = this.zv;
            if (a != b) {
                this.y7 = a;
                this.te("XAxisLabelTextStyle", b, this.zv);
            }
        }
        get aa0() {
            return this.zb;
        }
        set aa0(a) {
            let b = this.aa0;
            if (a != b) {
                this.zb = a;
                this.te("YAxisLabelTextStyle", b, this.aa0);
            }
        }
        get aaj() {
            return this.y9;
        }
        set aaj(a) {
            let b = this.aaj;
            if (a != b) {
                this.y9 = a;
                this.te("XAxisTitleTextStyle", b, this.aaj);
            }
        }
        get abo() {
            return this.zd;
        }
        set abo(a) {
            let b = this.abo;
            if (a != b) {
                this.zd = a;
                this.te("YAxisTitleTextStyle", b, this.abo);
            }
        }
        abu(a) {
            this.abr(a, (b) => b.leftMargin = this.x7);
            this.abr(a, (b) => b.topMargin = this.x9);
            this.abr(a, (b) => b.rightMargin = this.x8);
            this.abr(a, (b) => b.bottomMargin = this.x6);
            this.abr(a, (b) => b.textColor = this.act);
            this.abs(a, (b) => b.textColor = this.ac1);
            this.abs(a, (b) => b.leftMargin = this.yh);
            this.abs(a, (b) => b.topMargin = this.yk);
            this.abs(a, (b) => b.rightMargin = this.yj);
            this.abs(a, (b) => b.bottomMargin = this.yg);
            this.abr(a, (b) => b.textStyle = this.zv);
            this.abs(a, (b) => b.textStyle = this.aaj);
        }
        abw(a) {
            this.abr(a, (b) => b.leftMargin = this.yo);
            this.abr(a, (b) => b.topMargin = this.yq);
            this.abr(a, (b) => b.rightMargin = this.yp);
            this.abr(a, (b) => b.bottomMargin = this.yn);
            this.abr(a, (b) => b.textColor = this.acu);
            this.abs(a, (b) => b.textColor = this.ac8);
            this.abs(a, (b) => b.leftMargin = this.yy);
            this.abs(a, (b) => b.topMargin = this.y1);
            this.abs(a, (b) => b.rightMargin = this.y0);
            this.abs(a, (b) => b.bottomMargin = this.yx);
            this.abr(a, (b) => b.textStyle = this.aa0);
            this.abs(a, (b) => b.textStyle = this.abo);
        }
        tz(a) {
            let b = this.bc(a);
            let c = this.c2(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = a.data;
            if (a.highlightedData != null) {
                c.highlightedItemsSource = a.highlightedData;
            }
            c.name = this.or(a);
            c.title = this.os(a, b);
            this.dataChart.series.add(c);
        }
        abx(a) {
            this.aby(a, null);
        }
        aby(a, b) {
            a(this.wm());
        }
        ab3(a, b) {
            a(this.wn());
        }
        ab2(a) {
            this.ab3(a, true);
        }
        sb(a, b) {
            this.abx(a);
            this.ab3(a, b);
        }
        ab1(a) {
            this.abs(this.wm(), a);
        }
        ab6(a) {
            this.abs(this.wn(), a);
        }
        ab4(a) {
            this.abr(this.wn(), a);
        }
        abz(a) {
            this.abr(this.wm(), a);
        }
        x0(a) {
            let b = this.wm();
            return b.ej(a, new ScalerParams(1, this.vx, this.vw, b.ch));
        }
        x2(a) {
            let b = this.wm();
            return b.em(a, new ScalerParams(1, this.vx, this.vw, b.ch));
        }
        x1(a) {
            let b = this.wn();
            return b.ej(a, new ScalerParams(1, this.vx, this.vw, b.ch));
        }
        x3(a) {
            let b = this.wn();
            return b.em(a, new ScalerParams(1, this.vx, this.vw, b.ch));
        }
        tw(a) {
            super.tw(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.wm();
                let c = this.wn();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static zg(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        sm(a) {
            super.sm(a);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.wm());
                this.dataChart.axes.add(this.wn());
            }
        }
        abt(a) {
            if (a != null && this.kj != null && a.fl == null) {
                a.provideRenderer(this.kj);
            }
            a.jw = this.acw;
            a.er = this.ya;
            a.jx = this.acx;
            a.eu = this.yb;
            a.jz = this.acz;
            a.fg = this.yc;
            a.jy = this.acy;
            a.fh = this.yd;
            a.j0 = this.ac0;
            a.fi = this.ye;
            a.c4 = true;
            a.cu = this.gm;
            a.cw = this.gm;
            let b = a == this.wm();
            if (b) {
                a.g6 = this.aaa;
            }
            a.f0 = this.y4;
            a.gg = this.zm;
            a.ah = this.wk;
            this.abr(a, (c) => c.angle = this.x5);
            this.abr(a, (c) => {
                if (c.extent != this.x4) {
                    c.extent = this.x4;
                }
            });
            this.abr(a, (c) => c.horizontalAlignment = this.aca);
            this.abr(a, (c) => c.verticalAlignment = this.adc);
            this.abr(a, (c) => c.visibility = this.adh);
            this.abr(a, (c) => c.location = this.ws(this.wv));
            this.abs(a, (c) => c.horizontalAlignment = this.acb);
            this.abs(a, (c) => c.angle = this.yf);
            this.abu(a);
        }
        abv(a) {
            if (a == null) {
                return;
            }
            if (this.kj != null && a.fl == null) {
                a.provideRenderer(this.kj);
            }
            a.cu = this.gm;
            a.cw = this.gm;
            this.abr(a, (b) => b.angle = this.ym);
            this.abr(a, (b) => {
                if (b.extent != this.yl) {
                    b.extent = this.yl;
                }
            });
            this.abr(a, (b) => b.horizontalAlignment = this.acc);
            this.abr(a, (b) => b.verticalAlignment = this.add);
            this.abr(a, (b) => b.visibility = this.adi);
            this.abr(a, (b) => b.location = this.wt(this.wx));
            this.abs(a, (b) => b.verticalAlignment = this.ade);
            this.abs(a, (b) => b.angle = this.yw);
            a.jw = this.ac3;
            a.er = this.yr;
            a.jx = this.ac4;
            a.eu = this.ys;
            a.jz = this.ac6;
            a.fg = this.yt;
            a.jy = this.ac5;
            a.fh = this.yu;
            a.j0 = this.ac7;
            a.fi = this.yv;
            let b = a == this.wn();
            if (b) {
                a.g6 = this.abf;
            }
            a.gg = this.aar;
            a.ah = this.wl;
            this.abw(a);
        }
        sj() {
            super.sj();
            this.abt(this.wm());
            this.abv(this.wn());
        }
        abr(a, b) {
            if (a == null) {
                return;
            }
            if (a.az == null) {
                a.az = new AxisLabelSettings();
                a.az.angle = a.d5();
                a.az.bottomMargin = a.d6();
                a.az.leftMargin = a.d7();
                a.az.rightMargin = a.d8();
                a.az.topMargin = a.d9();
                a.az.horizontalAlignment = a.jr();
                a.az.location = a.a0();
                a.az.verticalAlignment = a.kk();
            }
            b(a.az);
        }
        abs(a, b) {
            if (a == null) {
                return;
            }
            if (a.bf == null) {
                a.bf = new TitleSettings();
                a.bf.bottomMargin = a.eb();
                a.bf.leftMargin = a.ec();
                a.bf.rightMargin = a.ed();
                a.bf.topMargin = a.ee();
                a.bf.location = a.a1();
                a.bf.angle = a.ea();
                a.bf.horizontalAlignment = a.js();
                a.bf.verticalAlignment = a.kl();
            }
            b(a.bf);
        }
        te(a, b, c) {
            super.te(a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.abz((d) => d.angle = this.x5);
                    break;
                case "YAxisLabelAngle":
                    this.ab4((d) => d.angle = this.ym);
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.abz((d) => d.horizontalAlignment = this.aca);
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.ab4((d) => d.horizontalAlignment = this.acc);
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.abz((d) => d.verticalAlignment = this.adc);
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.ab4((d) => d.verticalAlignment = this.add);
                    break;
                case "XAxisLabelVisibility":
                    this.abz((d) => d.visibility = this.adh);
                    break;
                case "YAxisLabelVisibility":
                    this.ab4((d) => d.visibility = this.adi);
                    break;
                case "XAxisLabel":
                    this.abx((d) => d.f0 = this.y4);
                    break;
                case "YAxisLabel":
                    this.ab2((d) => d.f0 = this.y5);
                    break;
                case "XAxisLabelFormat":
                    this.abx((d) => d.gg = this.zm);
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.abx((d) => d.ah = this.wk);
                    break;
                case "YAxisLabelFormat":
                    this.ab2((d) => d.gg = this.aar);
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.ab2((d) => d.ah = this.wl);
                    break;
                case "XAxisTitleAngle":
                    this.ab1((d) => d.angle = this.yf);
                    break;
                case "YAxisTitleAngle":
                    this.ab6((d) => d.angle = this.yw);
                    break;
                case "XAxisTitleAlignment":
                    this.ab1((d) => d.horizontalAlignment = this.acb);
                    break;
                case "YAxisTitleAlignment":
                    this.ab6((d) => d.verticalAlignment = this.ade);
                    break;
                case "XAxisTitle":
                    this.abx((d) => d.g6 = this.aaa);
                    break;
                case "YAxisTitle":
                    this.ab3((d) => d.g6 = this.abf, false);
                    break;
                case "XAxisMajorStroke":
                    this.aby((d) => d.jw = this.acw, a);
                    break;
                case "YAxisMajorStroke":
                    this.ab2((d) => d.jw = this.ac3);
                    break;
                case "XAxisMajorStrokeThickness":
                    this.aby((d) => d.er = this.ya, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.ab2((d) => d.er = this.yr);
                    break;
                case "XAxisMinorStroke":
                    this.abx((d) => d.jx = this.acx);
                    break;
                case "YAxisMinorStroke":
                    this.ab2((d) => d.jx = this.ac4);
                    break;
                case "XAxisMinorStrokeThickness":
                    this.abx((d) => d.eu = this.yb);
                    break;
                case "YAxisMinorStrokeThickness":
                    this.ab2((d) => d.eu = this.ys);
                    break;
                case "XAxisTickLength":
                    this.abx((d) => d.fh = this.yd);
                    break;
                case "YAxisTickLength":
                    this.ab2((d) => d.fh = this.yu);
                    break;
                case "XAxisTickStroke":
                    this.abx((d) => d.j0 = this.ac0);
                    break;
                case "YAxisTickStroke":
                    this.ab2((d) => d.j0 = this.ac7);
                    break;
                case "XAxisTickStrokeThickness":
                    this.abx((d) => d.fi = this.ye);
                    break;
                case "YAxisTickStrokeThickness":
                    this.ab2((d) => d.fi = this.yv);
                    break;
                case "XAxisStroke":
                    this.abx((d) => d.jz = this.acz);
                    break;
                case "YAxisStroke":
                    this.ab2((d) => d.jz = this.ac6);
                    break;
                case "XAxisStrokeThickness":
                    this.abx((d) => d.fg = this.yc);
                    break;
                case "YAxisStrokeThickness":
                    this.ab2((d) => d.fg = this.yt);
                    break;
                case "XAxisExtent":
                    this.abz((d) => d.extent = this.x4);
                    break;
                case "YAxisExtent":
                    this.ab4((d) => d.extent = this.yl);
                    break;
                case "XAxisStrip":
                    this.abx((d) => d.jy = this.acy);
                    break;
                case "YAxisStrip":
                    this.ab2((d) => d.jy = this.ac5);
                    break;
                case "XAxisInverted":
                    this.abx((d) => d.ch = this.w0);
                    break;
                case "YAxisInverted":
                    this.ab2((d) => d.ch = this.w1);
                    break;
                case "YAxisLabelLocation":
                    this.ab5();
                    break;
                case "XAxisLabelLocation":
                    this.ab0();
                    break;
            }
        }
        ab5() {
            let a = this.wt(this.wx);
            if (a == 2 || a == 7) {
                this.acc = 2;
            }
            else {
                this.acc = 0;
            }
            this.ab4((b) => b.location = a);
        }
        ab0() {
            let a = this.ws(this.wv);
            if (a == 1 || a == 5) {
                this.adc = 0;
            }
            else {
                this.adc = 2;
            }
            this.abz((b) => b.location = a);
        }
        wt(a) {
            if (a == 0) {
                return 2;
            }
            else if (a == 1) {
                return 3;
            }
            else if (a == 3) {
                return 7;
            }
            else if (a == 2) {
                return 6;
            }
            else {
                if (this.b1 == 1) {
                    return 3;
                }
                else {
                    return 2;
                }
            }
        }
        ws(a) {
            if (a == 1) {
                return 1;
            }
            else if (a == 0) {
                return 0;
            }
            else if (a == 3) {
                return 5;
            }
            else if (a == 2) {
                return 4;
            }
            else {
                return 1;
            }
        }
        get y4() {
            return this.y2;
        }
        set y4(a) {
            let b = this.y4;
            if (a != b) {
                this.y2 = a;
                this.te("XAxisLabel", b, this.y4);
            }
        }
        get y5() {
            return this.y3;
        }
        set y5(a) {
            let b = this.y5;
            if (a != b) {
                this.y3 = a;
                this.te("YAxisLabel", b, this.y5);
            }
        }
        get acw() {
            return this.acg;
        }
        set acw(a) {
            let b = this.acw;
            if (a != b) {
                this.acg = a;
                this.te("XAxisMajorStroke", b, this.acw);
            }
        }
        get ac3() {
            return this.acn;
        }
        set ac3(a) {
            let b = this.ac3;
            if (a != b) {
                this.acn = a;
                this.te("YAxisMajorStroke", b, this.ac3);
            }
        }
        get ya() {
            return this.w8;
        }
        set ya(a) {
            let b = this.ya;
            if (a != b) {
                this.w8 = a;
                this.te("XAxisMajorStrokeThickness", b, this.ya);
            }
        }
        get yr() {
            return this.xp;
        }
        set yr(a) {
            let b = this.yr;
            if (a != b) {
                this.xp = a;
                this.te("YAxisMajorStrokeThickness", b, this.yr);
            }
        }
        get yb() {
            return this.w9;
        }
        set yb(a) {
            let b = this.yb;
            if (a != b) {
                this.w9 = a;
                this.te("XAxisMinorStrokeThickness", b, this.yb);
            }
        }
        get ys() {
            return this.xq;
        }
        set ys(a) {
            let b = this.ys;
            if (a != b) {
                this.xq = a;
                this.te("YAxisMinorStrokeThickness", b, this.ys);
            }
        }
        get acy() {
            return this.aci;
        }
        set acy(a) {
            let b = this.acy;
            if (a != b) {
                this.aci = a;
                this.te("XAxisStrip", b, this.acy);
            }
        }
        get ac5() {
            return this.acp;
        }
        set ac5(a) {
            let b = this.ac5;
            if (a != b) {
                this.acp = a;
                this.te("YAxisStrip", b, this.ac5);
            }
        }
        get acz() {
            return this.acj;
        }
        set acz(a) {
            let b = this.acz;
            if (a != b) {
                this.acj = a;
                this.te("XAxisStroke", b, this.acz);
            }
        }
        get ac6() {
            return this.acq;
        }
        set ac6(a) {
            let b = this.ac6;
            if (a != b) {
                this.acq = a;
                this.te("YAxisStroke", b, this.ac6);
            }
        }
        get yc() {
            return this.xa;
        }
        set yc(a) {
            let b = this.yc;
            if (a != b) {
                this.xa = a;
                this.te("XAxisStrokeThickness", b, this.yc);
            }
        }
        get yt() {
            return this.xr;
        }
        set yt(a) {
            let b = this.yt;
            if (a != b) {
                this.xr = a;
                this.te("YAxisStrokeThickness", b, this.yt);
            }
        }
        get yd() {
            return this.xb;
        }
        set yd(a) {
            let b = this.yd;
            if (a != b) {
                this.xb = a;
                this.te("XAxisTickLength", b, this.yd);
            }
        }
        get yu() {
            return this.xs;
        }
        set yu(a) {
            let b = this.yu;
            if (a != b) {
                this.xs = a;
                this.te("YAxisTickLength", b, this.yu);
            }
        }
        get ac0() {
            return this.ack;
        }
        set ac0(a) {
            let b = this.ac0;
            if (a != b) {
                this.ack = a;
                this.te("XAxisTickStroke", b, this.ac0);
            }
        }
        get ac7() {
            return this.acr;
        }
        set ac7(a) {
            let b = this.ac7;
            if (a != b) {
                this.acr = a;
                this.te("YAxisTickStroke", b, this.ac7);
            }
        }
        get ye() {
            return this.xc;
        }
        set ye(a) {
            let b = this.ye;
            if (a != b) {
                this.xc = a;
                this.te("XAxisTickStrokeThickness", b, this.ye);
            }
        }
        get yv() {
            return this.xt;
        }
        set yv(a) {
            let b = this.yv;
            if (a != b) {
                this.xt = a;
                this.te("YAxisTickStrokeThickness", b, this.yv);
            }
        }
        get aaa() {
            return this.y8;
        }
        set aaa(a) {
            let b = this.aaa;
            if (a != b) {
                this.y8 = a;
                this.te("XAxisTitle", b, this.aaa);
            }
        }
        get abf() {
            return this.zc;
        }
        set abf(a) {
            let b = this.abf;
            if (a != b) {
                this.zc = a;
                this.te("YAxisTitle", b, this.abf);
            }
        }
        get acx() {
            return this.ach;
        }
        set acx(a) {
            let b = this.acx;
            if (a != b) {
                this.ach = a;
                this.te("XAxisMinorStroke", b, this.acx);
            }
        }
        get ac4() {
            return this.aco;
        }
        set ac4(a) {
            let b = this.ac4;
            if (a != b) {
                this.aco = a;
                this.te("YAxisMinorStroke", b, this.ac4);
            }
        }
        get x5() {
            return this.w3;
        }
        set x5(a) {
            let b = this.x5;
            if (a != b) {
                this.w3 = a;
                this.te("XAxisLabelAngle", b, this.x5);
            }
        }
        get ym() {
            return this.xk;
        }
        set ym(a) {
            let b = this.ym;
            if (a != b) {
                this.xk = a;
                this.te("YAxisLabelAngle", b, this.ym);
            }
        }
        get x4() {
            return this.w2;
        }
        set x4(a) {
            let b = this.x4;
            if (a != b) {
                this.w2 = a;
                this.te("XAxisExtent", b, this.x4);
            }
        }
        get yl() {
            return this.xj;
        }
        set yl(a) {
            let b = this.yl;
            if (a != b) {
                this.xj = a;
                this.te("YAxisExtent", b, this.yl);
            }
        }
        get yf() {
            return this.xd;
        }
        set yf(a) {
            let b = this.yf;
            if (a != b) {
                this.xd = a;
                this.te("XAxisTitleAngle", b, this.yf);
            }
        }
        get yw() {
            return this.xu;
        }
        set yw(a) {
            let b = this.yw;
            if (a != b) {
                this.xu = a;
                this.te("YAxisTitleAngle", b, this.yw);
            }
        }
        get w0() {
            return this.wy;
        }
        set w0(a) {
            let b = this.w0;
            if (a != b) {
                this.wy = a;
                this.te("XAxisInverted", b, this.w0);
            }
        }
        get w1() {
            return this.wz;
        }
        set w1(a) {
            let b = this.w1;
            if (a != b) {
                this.wz = a;
                this.te("YAxisInverted", b, this.w1);
            }
        }
        get acb() {
            return this.ab8;
        }
        set acb(a) {
            let b = this.acb;
            if (a != b) {
                this.ab8 = a;
                this.te("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.acb));
            }
        }
        get ade() {
            return this.adb;
        }
        set ade(a) {
            let b = this.ade;
            if (a != b) {
                this.adb = a;
                this.te("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ade));
            }
        }
        get aca() {
            return this.ab7;
        }
        set aca(a) {
            let b = this.aca;
            if (a != b) {
                this.ab7 = a;
                this.te("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aca));
            }
        }
        get_acc() {
            return this.ab9;
        }
        set_acc(a) {
            let b = this.acc;
            if (a != b) {
                this.ab9 = a;
                this.te("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.acc));
            }
        }
        get acc() {
            return this.get_acc();
        }
        set acc(a) {
            this.set_acc(a);
        }
        get adc() {
            return this.ac9;
        }
        set adc(a) {
            let b = this.adc;
            if (a != b) {
                this.ac9 = a;
                this.te("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.adc));
            }
        }
        get add() {
            return this.ada;
        }
        set add(a) {
            let b = this.add;
            if (a != b) {
                this.ada = a;
                this.te("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.add));
            }
        }
        get adh() {
            return this.adf;
        }
        set adh(a) {
            let b = this.adh;
            if (a != b) {
                this.adf = a;
                this.te("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.adh));
            }
        }
        get adi() {
            return this.adg;
        }
        set adi(a) {
            let b = this.adi;
            if (a != b) {
                this.adg = a;
                this.te("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.adi));
            }
        }
        get_wx() {
            return this.ww;
        }
        set_wx(a) {
            let b = this.wx;
            if (a != b) {
                this.ww = a;
                this.te("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.wx));
            }
        }
        get wx() {
            return this.get_wx();
        }
        set wx(a) {
            this.set_wx(a);
        }
        get_wv() {
            return this.wu;
        }
        set_wv(a) {
            let b = this.wv;
            if (a != b) {
                this.wu = a;
                this.te("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.wv));
            }
        }
        get wv() {
            return this.get_wv();
        }
        set wv(a) {
            this.set_wv(a);
        }
        get zm() {
            return this.y6;
        }
        set zm(a) {
            let b = this.y6;
            if (a != b) {
                this.y6 = a;
                this.te("XAxisLabelFormat", b, this.y6);
            }
        }
        get wk() {
            return this.wi;
        }
        set wk(a) {
            let b = this.wi;
            if (a != b) {
                this.wi = a;
                this.te("XAxisLabelFormatSpecifiers", b, this.wi);
            }
        }
        get aar() {
            return this.za;
        }
        set aar(a) {
            let b = this.za;
            if (a != b) {
                this.za = a;
                this.te("YAxisLabelFormat", b, this.za);
            }
        }
        get wl() {
            return this.wj;
        }
        set wl(a) {
            let b = this.wj;
            if (a != b) {
                this.wj = a;
                this.te("YAxisLabelFormatSpecifiers", b, this.wj);
            }
        }
    }
    XYChart.$t = /*@__PURE__*/ markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
})();
